module CLOCK #(
  parameter CLK_FREQ = 1
)(
  input          i_CLK,
  input          i_hlt,
  input          i_lcd_rdy,
//  output reg     o_lcd_clk,
  output reg     o_clk
);

wire pll_clk;
//0,35,5=18MHz 4=36MHz =>  9MHz
//0,39,5=20MHz 4=40MHz => 10MHz
//0,43,5=22MHz 4=44MHz => 11MHz
//0,47,5=24MHz 4=48MHz => 12MHz
//0,51,5=26MHz 4=52MHz => 13MHz (lcd: 1700,1710,1800,275000)
//0,63,5=32MHz 4=64MHz => 16MHz
SB_PLL40_CORE #(
  .FEEDBACK_PATH("SIMPLE"),
  .PLLOUT_SELECT("GENCLK"),
  .DIVR(0),
  .DIVF(47),
  .DIVQ(4),
  .FILTER_RANGE(1)
)
uut
(
  .REFERENCECLK(i_CLK),
  .PLLOUTGLOBAL(pll_clk),
  .RESETB(1'b1),
  .BYPASS(1'b0)
);

reg [25:0] maxcount = (24000000/CLK_FREQ);
reg [25:0] ccount;
always @(posedge pll_clk) begin
  if (i_lcd_rdy) begin
    if (~i_hlt) begin
      if (ccount >= maxcount) begin // pll_clk/2
        ccount <= 26'd1;
        o_clk <= ~o_clk;
      end else
        ccount <= ccount + 26'd1;
    end else begin
      ccount <= 26'd0;
      o_clk <= 1'b0;
    end
  end
end
/*
reg [25:0]       ccount;
reg                 clk2 = 0;
wire                xclk = (clk2 ^ pll_clk);
always @(posedge xclk) begin // bij posedge AND negedge van pll_clk
  clk2 = ~clk2;
  if (i_lcd_rdy) begin
    if (~i_hlt) begin
      if (ccount >= (26000000 / CLK_FREQ)) begin
        ccount <= 1;
        o_clk <= ~o_clk;
      end else
        ccount <= ccount + 1;
    end else begin
      ccount <= 0;
      o_clk <= 1'b0;
    end
  end
end
*/
endmodule
